#include<stdio.h>
main()
{
    long int n,q,i,l,r,p;
    scanf("%ld%ld",&n,&q);
    long int a[n],resenje[q];
    for(i=0;i<n;i++)
        scanf("%ld",&a[i]);
    for(p=0;p<q;p++)
    {
        scanf("%ld%ld",&l,&r);
        for(i=l;i<r;i++)
        {
            if(i!=l)
                resenje[p]=resenje[p]&a[i];
            else
                resenje[p]=a[i-1]&a[i];
        }
    }
    for(p=0;p<q;p++)
    {
        printf("%ld\n",resenje[p]);
    }
}